import scala.concurrent._, scala.concurrent.duration._

import monix.execution.Scheduler.Implicits.global

import info.hupel.isabelle._, info.hupel.isabelle.api._, info.hupel.isabelle.setup._

object Test {
  def main(args : Array[String]) : Unit = {
      val setup = Setup.default(Version.Stable("2018"), false).right.get

      val resources = Resources.dumpIsabelleResources().right.get

      val config = Configuration.simple("Protocol")

      val env = Await.result(setup.makeEnvironment(resources, Nil), Duration.Inf)
      
      System.build(env, config)

      val system = Await.result(System.create(env, config), Duration.Inf)

      println("System created")

      // Succeeds (but shouldn't)
      val response = Await.result(system.invoke(Operation.UseThys)(List("TestEx")), Duration.Inf).unsafeGet
      
      // Does not succeed
      // val response = Await.result(system.invoke(Operation.implicitly[List[String], Unit]("use_thys"))(List("TestEx")), Duration.Inf).unsafeGet

      println("Thy",response)

      sys.exit(0)
  }
}
